
int htmldebug[256];

Keyword htmltags[] = {
	/* name,	autoend,	inline */
	{ L"a",		0,	1	},
	{ L"abbr",		0,	0	},
	{ L"acronym",		0,	0	},
	{ L"address",		0,	0	},
	{ L"applet",		0,	0	},
	{ L"area",		1,	0	},
	{ L"b",		0,	1	},
	{ L"base",		1,	0	},
	{ L"basefont",		1,	0	},
	{ L"bdo",		0,	0	},
	{ L"big",		0,	1	},
	{ L"blockquote",		0,	0	},
	{ L"body",		0,	0	},
	{ L"br",		1,	1	},
	{ L"button",		0,	0	},
	{ L"canvas",		0,	0	},
	{ L"caption",		0,	0	},
	{ L"center",		0,	0	},
	{ L"cite",		0,	1	},
	{ L"code",		0,	1	},
	{ L"col",		1,	0	},
	{ L"colgroup",		0,	0	},
	{ L"dd",		0,	0	},
	{ L"del",		0,	0	},
	{ L"dfn",		0,	1	},
	{ L"dir",		0,	0	},
	{ L"div",		0,	0	},
	{ L"dl",		0,	0	},
	{ L"dt",		0,	0	},
	{ L"em",		0,	1	},
	{ L"embed",		0,	0	},
	{ L"fieldset",		0,	1	},
	{ L"font",		0,	1	},
	{ L"form",		0,	0	},
	{ L"frame",		1,	0	},
	{ L"frameset",		0,	0	},
	{ L"h1",		0,	0	},
	{ L"h2",		0,	0	},
	{ L"h3",		0,	0	},
	{ L"h4",		0,	0	},
	{ L"h5",		0,	0	},
	{ L"h6",		0,	0	},
	{ L"head",		0,	0	},
	{ L"hr",		1,	0	},
	{ L"html",		0,	0	},
	{ L"i",		0,	1	},
	{ L"iframe",		0,	0	},
	{ L"img",		1,	1	},
	{ L"input",		1,	1	},
	{ L"ins",		0,	0	},
	{ L"isindex",		1,	0	},
	{ L"kbd",		0,	1	},
	{ L"keygen",		0,	0	},
	{ L"label",		0,	1	},
	{ L"layer",		0,	0	},
	{ L"legend",		0,	1	},
	{ L"li",		0,	0	},
	{ L"link",		1,	0	},
	{ L"map",		0,	1	},
	{ L"marquee",		0,	0	},
	{ L"menu",		0,	0	},
	{ L"meta",		1,	0	},
	{ L"nobr",		0,	0	},
	{ L"noembed",		0,	0	},
	{ L"noframes",		0,	0	},
	{ L"nolayer",		0,	0	},
	{ L"noscript",		0,	0	},
	{ L"object",		0,	0	},
	{ L"ol",		0,	0	},
	{ L"optgroup",		0,	0	},
	{ L"option",		0,	1	},
	{ L"p",		0,	0	},
	{ L"param",		1,	0	},
	{ L"plaintext",		0,	0	},
	{ L"pre",		0,	0	},
	{ L"q",		0,	0	},
	{ L"s",		0,	1	},
	{ L"samp",		0,	1	},
	{ L"script",		0,	1	},
	{ L"select",		0,	1	},
	{ L"small",		0,	1	},
	{ L"spacer",	0,	1	},
	{ L"span",		0,	1	},
	{ L"strike",		0,	1	},
	{ L"strong",		0,	1	},
	{ L"style",		0,	0	},
	{ L"sub",		0,	1	},
	{ L"sup",		0,	1	},
	{ L"table",		0,	0	},
	{ L"tbody",		0,	0	},
	{ L"td",		0,	0	},
	{ L"textarea",		0,	1	},
	{ L"tfoot",		0,	0	},
	{ L"th",		0,	0	},
	{ L"thead",		0,	0	},
	{ L"title",		0,	0	},
	{ L"tr",		0,	0	},
	{ L"tt",		0,	1	},
	{ L"u",		0,	1	},
	{ L"ul",		0,	0	},
	{ L"var",		0,	1	},
	{ L"wbr",		0,	0	},
	{ L"xmp",		0,	0	},
};

static Rune *attributes[] = {
	L"abbr",
	L"accept",
	L"accept-charset",
	L"accesskey",
	L"action",
	L"align",
	L"alink",
	L"alt",
	L"archive",
	L"autocomplete",
	L"autosave",
	L"axis",
	L"background",
	L"behavior",
	L"bgcolor",
	L"bgproperties",
	L"border",
	L"bordercolor",
	L"cellborder",
	L"cellpadding",
	L"cellspacing",
	L"challenge",
	L"char",
	L"charoff",
	L"charset",
	L"checked",
	L"cite",
	L"class",
	L"classid",
	L"clear",
	L"code",
	L"codebase",
	L"codetype",
	L"color",
	L"cols",
	L"colspan",
	L"compact",
	L"composite",
	L"content",
	L"contenteditable",
	L"coords",
	L"data",
	L"datetime",
	L"declare",
	L"defer",
	L"dir",
	L"direction",
	L"disabled",
	L"enctype",
	L"face",
	L"for",
	L"frame",
	L"frameborder",
	L"headers",
	L"height",
	L"hidden",
	L"href",
	L"hreflang",
	L"hspace",
	L"html",
	L"http-equiv",
	L"id",
	L"incremental",
	L"ismap",
	L"keytype",
	L"label",
	L"lang",
	L"language",
	L"left",
	L"leftmargin",
	L"link",
	L"longdesc",
	L"loop",
	L"marginheight",
	L"marginwidth",
	L"max",
	L"maxlength",
	L"mayscript",
	L"media",
	L"method",
	L"min",
	L"multiple",
	L"name",
	L"nohref",
	L"noresize",
	L"nosave",
	L"noshade",
	L"nowrap",
	L"object",
	L"onabort",
	L"onbeforecopy",
	L"onbeforecut",
	L"onbeforepaste",
	L"onblur",
	L"onchange",
	L"onclick",
	L"oncontextmenu",
	L"oncopy",
	L"oncut",
	L"ondblclick",
	L"ondrag",
	L"ondragend",
	L"ondragenter",
	L"ondragleave",
	L"ondragover",
	L"ondragstart",
	L"ondrop",
	L"onerror",
	L"onfocus",
	L"oninput",
	L"onkeydown",
	L"onkeypress",
	L"onkeyup",
	L"onload",
	L"onmousedown",
	L"onmousemove",
	L"onmouseout",
	L"onmouseover",
	L"onmouseup",
	L"onpaste",
	L"onreset",
	L"onresize",
	L"onscroll",
	L"onsearch",
	L"onselect",
	L"onselectstart",
	L"onsubmit",
	L"onunload",
	L"oversrc",
	L"pagex",
	L"pagey",
	L"placeholder",
	L"plain",
	L"pluginpage",
	L"pluginspage",
	L"pluginurl",
	L"precision",
	L"profile",
	L"prompt",
	L"readonly",
	L"rel",
	L"results",
	L"rev",
	L"rows",
	L"rowspan",
	L"rules",
	L"scheme",
	L"scope",
	L"scrollamount",
	L"scrolldelay",
	L"scrolling",
	L"selected",
	L"shape",
	L"size",
	L"span",
	L"src",
	L"standby",
	L"start",
	L"style",
	L"summary",
	L"tabindex",
	L"tableborder",
	L"target",
	L"text",
	L"title",
	L"top",
	L"topmargin",
	L"truespeed",
	L"type",
	L"unknown",
	L"usemap",
	L"valign",
	L"value",
	L"valuetype",
	L"version",
	L"visibility",
	L"vlink",
	L"vspace",
	L"width",
	L"wrap",
};

Keyword	htmlentities[]= {
	{L"AElig", 198, 0},
	{L"Aacute", 193, 0},
	{L"Acirc", 194, 0},
	{L"Agrave", 192, 0},
	{L"Alpha", 913, 0},
	{L"Aring", 197, 0},
	{L"Atilde", 195, 0},
	{L"Auml", 196, 0},
	{L"Beta", 914, 0},
	{L"Ccedil", 199, 0},
	{L"Chi", 935, 0},
	{L"Dagger", 8225, 0},
	{L"Delta", 916, 0},
	{L"ETH", 208, 0},
	{L"Eacute", 201, 0},
	{L"Ecirc", 202, 0},
	{L"Egrave", 200, 0},
	{L"Epsilon", 917, 0},
	{L"Eta", 919, 0},
	{L"Euml", 203, 0},
	{L"Gamma", 915, 0},
	{L"Iacute", 205, 0},
	{L"Icirc", 206, 0},
	{L"Igrave", 204, 0},
	{L"Iota", 921, 0},
	{L"Iuml", 207, 0},
	{L"Kappa", 922, 0},
	{L"Lambda", 923, 0},
	{L"Mu", 924, 0},
	{L"Ntilde", 209, 0},
	{L"Nu", 925, 0},
	{L"OElig", 338, 0},
	{L"Oacute", 211, 0},
	{L"Ocirc", 212, 0},
	{L"Ograve", 210, 0},
	{L"Omega", 937, 0},
	{L"Omicron", 927, 0},
	{L"Oslash", 216, 0},
	{L"Otilde", 213, 0},
	{L"Ouml", 214, 0},
	{L"Phi", 934, 0},
	{L"Pi", 928, 0},
	{L"Prime", 8243, 0},
	{L"Psi", 936, 0},
	{L"Rho", 929, 0},
	{L"Scaron", 352, 0},
	{L"Sigma", 931, 0},
	{L"THORN", 222, 0},
	{L"Tau", 932, 0},
	{L"Theta", 920, 0},
	{L"Uacute", 218, 0},
	{L"Ucirc", 219, 0},
	{L"Ugrave", 217, 0},
	{L"Upsilon", 933, 0},
	{L"Uuml", 220, 0},
	{L"Xi", 926, 0},
	{L"Yacute", 221, 0},
	{L"Yuml", 376, 0},
	{L"Zeta", 918, 0},
	{L"aacute", 225, 0},
	{L"acirc", 226, 0},
	{L"acute", 180, 0},
	{L"aelig", 230, 0},
	{L"agrave", 224, 0},
	{L"alefsym", 8501, 0},
	{L"alpha", 945, 0},
	{L"amp", 38, 0},
	{L"and", 8743, 0},
	{L"ang", 8736, 0},
	{L"aring", 229, 0},
	{L"asymp", 8776, 0},
	{L"atilde", 227, 0},
	{L"auml", 228, 0},
	{L"bdquo", 8222, 0},
	{L"beta", 946, 0},
	{L"brvbar", 166, 0},
	{L"bull", 8226, 0},
	{L"cap", 8745, 0},
	{L"ccedil", 231, 0},
	{L"cdots", 8943, 0},
	{L"cedil", 184, 0},
	{L"cent", 162, 0},
	{L"chi", 967, 0},
	{L"circ", 710, 0},
	{L"clubs", 9827, 0},
	{L"cong", 8773, 0},
	{L"copy", 169, 0},
	{L"crarr", 8629, 0},
	{L"cup", 8746, 0},
	{L"curren", 164, 0},
	{L"dArr", 8659, 0},
	{L"dagger", 8224, 0},
	{L"darr", 8595, 0},
	{L"ddots", 8945, 0},
	{L"deg", 176, 0},
	{L"delta", 948, 0},
	{L"diams", 9830, 0},
	{L"divide", 247, 0},
	{L"eacute", 233, 0},
	{L"ecirc", 234, 0},
	{L"egrave", 232, 0},
	{L"emdash", 8212, 0},	/* non-standard but commonly used */
	{L"empty", 8709, 0},
	{L"emsp", 8195, 0},
	{L"endash", 8211, 0},	/* non-standard but commonly used */
	{L"ensp", 8194, 0},
	{L"epsilon", 949, 0},
	{L"equiv", 8801, 0},
	{L"eta", 951, 0},
	{L"eth", 240, 0},
	{L"euml", 235, 0},
	{L"euro", 8364, 0},
	{L"exist", 8707, 0},
	{L"fnof", 402, 0},
	{L"forall", 8704, 0},
	{L"frac12", 189, 0},
	{L"frac14", 188, 0},
	{L"frac34", 190, 0},
	{L"frasl", 8260, 0},
	{L"gamma", 947, 0},
	{L"ge", 8805, 0},
	{L"gt", 62, 0},
	{L"hArr", 8660, 0},
	{L"harr", 8596, 0},
	{L"hearts", 9829, 0},
	{L"hellip", 8230, 0},
	{L"iacute", 237, 0},
	{L"icirc", 238, 0},
	{L"iexcl", 161, 0},
	{L"igrave", 236, 0},
	{L"image", 8465, 0},
	{L"infin", 8734, 0},
	{L"int", 8747, 0},
	{L"iota", 953, 0},
	{L"iquest", 191, 0},
	{L"isin", 8712, 0},
	{L"iuml", 239, 0},
	{L"kappa", 954, 0},
	{L"lArr", 8656, 0},
	{L"lambda", 955, 0},
	{L"lang", 9001, 0},
	{L"laquo", 171, 0},
	{L"larr", 8592, 0},
	{L"lceil", 8968, 0},
	{L"ldots", 8230, 0},
	{L"ldquo", 8220, 0},
	{L"le", 8804, 0},
	{L"lfloor", 8970, 0},
	{L"lowast", 8727, 0},
	{L"loz", 9674, 0},
	{L"lrm", 8206, 0},
	{L"lsaquo", 8249, 0},
	{L"lsquo", 8216, 0},
	{L"lt", 60, 0},
	{L"macr", 175, 0},
	{L"mdash", 8212, 0},
	{L"micro", 181, 0},
	{L"middot", 183, 0},
	{L"minus", 8722, 0},
	{L"mu", 956, 0},
	{L"nabla", 8711, 0},
	{L"nbsp", 160, 0},
	{L"ndash", 8211, 0},
	{L"ne", 8800, 0},
	{L"ni", 8715, 0},
	{L"not", 172, 0},
	{L"notin", 8713, 0},
	{L"nsub", 8836, 0},
	{L"ntilde", 241, 0},
	{L"nu", 957, 0},
	{L"oacute", 243, 0},
	{L"ocirc", 244, 0},
	{L"oelig", 339, 0},
	{L"ograve", 242, 0},
	{L"oline", 8254, 0},
	{L"omega", 969, 0},
	{L"omicron", 959, 0},
	{L"oplus", 8853, 0},
	{L"or", 8744, 0},
	{L"ordf", 170, 0},
	{L"ordm", 186, 0},
	{L"oslash", 248, 0},
	{L"otilde", 245, 0},
	{L"otimes", 8855, 0},
	{L"ouml", 246, 0},
	{L"para", 182, 0},
	{L"part", 8706, 0},
	{L"permil", 8240, 0},
	{L"perp", 8869, 0},
	{L"phi", 966, 0},
	{L"pi", 960, 0},
	{L"piv", 982, 0},
	{L"plusmn", 177, 0},
	{L"pound", 163, 0},
	{L"prime", 8242, 0},
	{L"prod", 8719, 0},
	{L"prop", 8733, 0},
	{L"psi", 968, 0},
	{L"quad", 8193, 0},
	{L"quot", 34, 0},
	{L"rArr", 8658, 0},
	{L"radic", 8730, 0},
	{L"rang", 9002, 0},
	{L"raquo", 187, 0},
	{L"rarr", 8594, 0},
	{L"rceil", 8969, 0},
	{L"rdquo", 8221, 0},
	{L"real", 8476, 0},
	{L"reg", 174, 0},
	{L"rfloor", 8971, 0},
	{L"rho", 961, 0},
	{L"rlm", 8207, 0},
	{L"rsaquo", 8250, 0},
	{L"rsquo", 8217, 0},
	{L"sbquo", 8218, 0},
	{L"scaron", 353, 0},
	{L"sdot", 8901, 0},
	{L"sect", 167, 0},
	{L"shy", 173, 0},
	{L"sigma", 963, 0},
	{L"sigmaf", 962, 0},
	{L"sim", 8764, 0},
	{L"sp", 8194, 0},
	{L"spades", 9824, 0},
	{L"sub", 8834, 0},
	{L"sube", 8838, 0},
	{L"sum", 8721, 0},
	{L"sup", 8835, 0},
	{L"sup1", 185, 0},
	{L"sup2", 178, 0},
	{L"sup3", 179, 0},
	{L"supe", 8839, 0},
	{L"szlig", 223, 0},
	{L"tau", 964, 0},
	{L"there4", 8756, 0},
	{L"theta", 952, 0},
	{L"thetasym", 977, 0},
	{L"thinsp", 8201, 0},
	{L"thorn", 254, 0},
	{L"tilde", 732, 0},
	{L"times", 215, 0},
	{L"trade", 8482, 0},
	{L"uArr", 8657, 0},
	{L"uacute", 250, 0},
	{L"uarr", 8593, 0},
	{L"ucirc", 251, 0},
	{L"ugrave", 249, 0},
	{L"uml", 168, 0},
	{L"upsih", 978, 0},
	{L"upsilon", 965, 0},
	{L"uuml", 252, 0},
	{L"varepsilon", 8712, 0},
	{L"varphi", 981, 0},
	{L"varpi", 982, 0},
	{L"varrho", 1009, 0},
	{L"vdots", 8942, 0},
	{L"vsigma", 962, 0},
	{L"vtheta", 977, 0},
	{L"weierp", 8472, 0},
	{L"xi", 958, 0},
	{L"yacute", 253, 0},
	{L"yen", 165, 0},
	{L"yuml", 255, 0},
	{L"zeta", 950, 0},
	{L"zwj", 8205, 0},
	{L"zwnj", 8204, 0},
};
