#include <u.h>
#include <libc.h>
#include "html.h"

void *
emalloc(ulong n)
{
	void *p;

	p = malloc(n);
	if(p == nil)
		sysfatal("malloc failed");
	setmalloctag(p, getcallerpc(&n));
	memset(p, 0, n);
	return p;
}

void *
erealloc(void *p, ulong n)
{
	p = realloc(p, n);
	if(p == nil)
		sysfatal("realloc failed");
	setmalloctag(p, getcallerpc(&n));
	return p;
}

void
main(int argc, char **argv)
{
	HtmlParser p;
	Rune *name;
	char buf[8192];
	int fd, n, c, fflag, tflag;

	fflag = 1;
	tflag = 0;
	ARGBEGIN{
	case 'f':
		fflag = 0;
		break;
	case 't':
		tflag++;
		break;
	default:
		c = ARGC();
		if(c>=0 && c<256)
			htmldebug[c]++;
		break;
	}ARGEND

	memset(&p, 0, sizeof(HtmlParser));
	if(argc){
		fd = open(argv[0], OREAD);
		if(fd < 0)
			sysfatal("open: %r");
		name = runesmprint("%s", argv[0]);
	}else{
		fd = 0;
		name = L"stdin";
	}

	htmlinit(&p, name);
	for(;;){
		n = read(fd, buf, sizeof(buf));
		if(n <= 0)
			break;
		htmlparse(&p, buf, n);
	}
	htmlparse(&p, nil, 0);
	if(tflag){
		print("== TREE ==\n");
		htmlprtree(p.html);
	}
	if(fflag){
//		print("== HEAD ==\n");
		htmlprtext(p.head);
//		print("== BODY ==\n");
		htmlprtext(p.body);
	}
	freenode(p.html, 1);
	p.html = nil;
	p.body = nil;
	p.head = nil;
	exits(nil);
}
